<?php
/******************************************************************************
* LanguageCompare.php                                                         *
*******************************************************************************
* For SMF: Simple Machines Forum                                              *
* Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                *
* =========================================================================== *
* Software Version:           SMF 1.1.4+                                      *
* File Version:               1.0.0                                           *
* Software by:                DIN1031                                         *
* Copyright 2008 by:	     		DIN1031									                        *
* Support, News, Updates at:  http://mods.simplemachines.org                  *
*******************************************************************************
* This program is free software; you may redistribute it and/or modify it     *
* under the terms of the provided license as published by SMF.                *
*                                                                             *
* This program is distributed in the hope that it is and will be useful,      *
* but WITHOUT ANY WARRANTIES; without even any implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
******************************************************************************/
if (!defined('SMF'))
	die('Hacking attempt...');

/*
	void languageCompare()
		- Handles the sub action
		- preload the data for the current activated languages
		- check if the master language exists
		- check if at least more the one language exists
	
	void languageCompare_Select()
		- Load the small pull down *g*
		- Nothing more really ;P
	
	void languageCompare_StartCompare()
		- Check the $_REQUEST if the language avaible
		- Do the compare of the Languages

	bool loadLangaugeSpecial()
		- load each time at least the english language for the Language Compare
		- it's a compare tool, and i think it better to load something in English before nothing is load!
*/
	
function languageCompare() {

	global $txt, $scripturl, $topic, $db_prefix, $modSettings, $board, $ID_MEMBER, $user_info;
	global $sc, $board_info, $context, $settings, $sourcedir, $func;

	//Load some Languagefiles :)
	loadLanguage('Errors');
	loadLanguageSpecial();

	// Boldify "Topics Redirect" on the admin bar.
	adminIndex('languageCompare');

	$subActions = array(
		'compare' => array('languageCompare_StartCompare', 'admin_forum'),
		'select' => array('languageCompare_Select', 'admin_forum'),
	);

	// Default the sub-action to 'view ban list'.
	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'select';

	// Make sure you can do this.
	isAllowedTo($subActions[$_REQUEST['sa']][1]);

	$context['page_title'] = $txt['langCompare_titel'];

	// Tabs for browsing the different ban functions.
	$context['admin_tabs'] = array(
		'title' => $txt['langCompare_titel'],
		'description' => $txt['langCompare_desc'],
		'tabs' => array()
	);
	
	if (allowedTo('admin_forum'))
	{
		$context['admin_tabs']['tabs'][] = array(
			'title' => $txt['langCompare_titel'],
			'description' => $txt['langCompare_desc'],
			'href' => $scripturl . '?action=langcompare',
			'is_selected' => $_REQUEST['sa'] == 'select',
		);
	}
	
	//Only Somthing i will be sure off...
	if(isset($_REQUEST['compare']))
		$_REQUEST['compare'] = (string) $_REQUEST['compare'];
	
	//Load the Existing Languages, also with the special Versions :x
	// Are languages user selectable?  If so, get a list.
	$context['languages'] = array();
	$context['masterFilesFound'] = false;
	
	//Copy and Paste... yes you will find nearly the same in the Profile.php
	$language_directories = array(
		$settings['default_theme_dir'] . '/languages',
		$settings['actual_theme_dir'] . '/languages',
	);
	if (!empty($settings['base_theme_dir']))
		$language_directories[] = $settings['base_theme_dir'] . '/languages';
	$language_directories = array_unique($language_directories);

	foreach ($language_directories as $language_dir)
	{
		if (!file_exists($language_dir))
			continue;

		$dir = dir($language_dir);
		while ($entry = $dir->read())
		{
			// Each language file must *at least* have a 'index.LANGUAGENAME.php' file.
			if (preg_match('~^index\.(.+)\.php$~', $entry, $matches) == 0)
				continue;

			//I need at least english as master!
			if($matches[1] == 'english') {
				$context['masterFilesFound'] = true;
				continue;
			}
			
			$context['languages'][$matches[1]] = array(
				'name' => $func['ucwords'](strtr($matches[1], array('_' => ' '))),
				'current_dir' => $language_dir,
				'filename' => $matches[1],
			);
		}
		$dir->close();
	}
	
	foreach($context['languages'] as $key => $item) {
		$context['admin_tabs']['tabs'][] = array(
			'title' => $txt['langCompare_CompareTitel'].' ('.$item['name'].')',
			'description' => $txt['langCompare_CompareDesc'],
			'href' => $scripturl . '?action=langcompare;sa=compare;compare='.$key,
			'is_selected' => (!empty($_REQUEST['compare']) && $_REQUEST['compare'] == $key),
		);
	}
		
	//This is a Standard if this not in it, the mod is not usefull for you :)
	if($context['masterFilesFound'] && empty($context['languages']))
		fatal_error($txt['langCompare_noSecondLanguage'], false);
	elseif(!$context['masterFilesFound'])
		fatal_error($txt['langCompare_noMasterLanguage'], false);

	// Call the right function for this sub-acton.
	$subActions[$_REQUEST['sa']][0]();
}

function languageCompare_Select() {
	global $txt, $scripturl, $topic, $db_prefix, $modSettings, $board, $ID_MEMBER, $user_info;
	global $sc, $board_info, $context, $settings, $sourcedir;
	
	$context['sub_template'] = 'LanguageCompareSelect';
}

function languageCompare_StartCompare() {
	global $txt, $scripturl, $topic, $db_prefix, $modSettings, $board, $ID_MEMBER, $user_info;
	global $sc, $board_info, $context, $settings, $sourcedir, $func, $helptxt, $boardurl;
	
	//Gna i hate this!
	if(empty($_REQUEST['compare']) || empty($context['languages'][$_REQUEST['compare']]))
		redirectexit('action=langcompare');

	$context['sub_template'] = 'LanguageCompare';
	$context['compared_language'] = $_REQUEST['compare'];
	
	//First load all the language files who i need...
	$context['language_files'] = array(
		'english' => array(),
		$context['compared_language'] => array(),
	);

	//Copy and Paste... yes you will find nearly the same in the Profile.php
	$language_directories = array(
		$settings['default_theme_dir'] . '/languages',
		$settings['actual_theme_dir'] . '/languages',
	);
	if (!empty($settings['base_theme_dir']))
		$language_directories[] = $settings['base_theme_dir'] . '/languages';
	$language_directories = array_unique($language_directories);

	foreach ($language_directories as $language_dir)
	{
		if (!file_exists($language_dir))
			continue;

		$dir = dir($language_dir);
		while ($entry = $dir->read())
		{
			//Each Languagefile is NAME.LANGUAGE.php
			$matches = explode('.', $entry, 3);
			
			if(($matches[1] != 'english' && $matches[1] != $context['compared_language']) || strtolower($matches[2]) != 'php')
				continue;
			
			$context['language_files'][$matches[1]][$matches[0]] = array(
				'name' => $func['ucwords'](strtr($matches[0], array('_' => ' '))),
				'current_dir' => $language_dir,
				'filename' => $entry,
			);
		}
		$dir->close();
	}

	//Compare it... first find missing files, i don't need to compare this files :)
	$context['missing_files'] = array();
	$compare_diff = array_diff(array_keys($context['language_files']['english']), array_keys($context['language_files'][$context['compared_language']]));
	if(!empty($compare_diff)) {
		foreach($compare_diff as $item) {
			$context['missing_files'][$item] = $context['language_files']['english'][$item];
			$context['missing_files'][$item]['renamed'] = str_replace('.english.', '.'.$context['compared_language'].'.', $context['language_files']['english'][$item]['filename']);
			unset($context['language_files']['english'][$item]);
		}
	}
	
	//Okay Let's start the have compare :)
	//Store some data, i need to replace them back after the compare
	$oldTxt = $txt;	
	if(!empty($helptxt))
		$oldHelp = $helptxt;
	else
		$oldHelp = array();
	
	$context['missing_strings'] = array();
	
	//Prepare some evertime loaded thing ;)
	$txt = array();
	include($context['language_files']['english']['index']['current_dir'].'/'.$context['language_files']['english']['index']['filename']);
	$orginalIndexTxt = $txt;
	
	$txt = array();
	include($context['language_files'][$context['compared_language']]['index']['current_dir'].'/'.$context['language_files'][$context['compared_language']]['index']['filename']);
	$compareIndexTxt = $txt;
	
	foreach($context['language_files']['english'] as $name => $orginalItem) {
		$compareItem = $context['language_files'][$context['compared_language']][$name];
		
		//Load the data :)	
		$txt = ($name != 'index' ? $orginalIndexTxt : array());
		$helptxt = array();
		include($orginalItem['current_dir'].'/'.$orginalItem['filename']);
		$orginalTxt = array_diff($txt, ($name != 'index' ? $orginalIndexTxt : array()));
		$orginalHelpTxt = $helptxt;
		
		$txt = ($name != 'index' ? $compareIndexTxt : array());
		include($compareItem['current_dir'].'/'.$compareItem['filename']);
		$compareTxt = $txt;
		$compareHelpTxt = $helptxt;
		
		//Compare :)
		$compareKeys = array_keys($compareTxt);
		$orginalKeys = array_keys($orginalTxt);
		
		//What are the diffrents between this two files :)
		$compareDiff = array_diff($orginalKeys, $compareKeys);
		
		if(!empty($compareDiff)) {
			foreach($compareDiff as $var) 
				$context['missing_strings'][$name][] = array(
					'type' => 'txt',
					'name' => $var,
					'string' => htmlspecialchars($orginalTxt[$var], ENT_QUOTES),
				);
		}
		
		if(!empty($orginalHelpTxt)) {
			//Compare :)
			$compareKeys = array_keys($compareHelpTxt);
			$orginalKeys = array_keys($orginalHelpTxt);
			
			//What are the diffrents between this two files :)
			$compareDiff = array_diff($orginalKeys, $compareKeys);
			
			if(!empty($compareDiff)) {
				foreach($compareDiff as $var) 
					$context['missing_strings'][$name][] = array(
						'type' => 'helptxt',
						'name' => $var,
						'string' => htmlspecialchars($orginalHelpTxt[$var], ENT_QUOTES),
					);
			}		
		}
	}
	
	//Back to Normal :)	
	$txt = $oldTxt;
	$helptxt = $oldHelp;
}

function loadLanguageSpecial() {
	global $settings, $txt;
	
	//if all this strings exists, than i need nothing to replace and can return without problems :D
	$checkUp = array(
		'titel',
		'desc',
		'CompareTitel',
		'CompareDesc',
		'noMasterLanguage',
		'noSecondLanguage',
		'selectLanguage',
		'startCompare',
		'compareWith',
		'missingFiles',
		'noMissingFiles',
		'MissingCopyDir',
		'MissingCopyFile',
		'MissingCopyTo',
		'MissingCopyInfo',
		'missingStrings',
		'inTheFile',
		'appearFollowString',
		'Variable',
		'TextString',
		'MissingStringInfo',
	);

	$replaceWith = array();
	
	foreach ($checkUp as $item) {
		if(empty($txt['langCompare_'.$item]))
			$replaceWith[] = $item;
	}
	
	//Complete Translated?
	if(empty($replaceWith))
		return true;
	
	//Store the current $txt data for later replace
	$oldtxt = $txt;
	$txt = array();
	require_once($settings['default_theme_dir'].'/languages/Modifications.english.php');
	$dataTxt = $txt;
	$txt = $oldtxt;

	//Now Replace the unkown things into the array :)	
	foreach($replaceWith as $item) {
		$txt['langCompare_'.$item] = $dataTxt['langCompare_'.$item];
	}

	return true;
} 
?>